/* This file is an amalgamation of several source files.
   Please look for BEGIN FILE,END FILE and CONTINUE FILE
   strings to browse contents of individual files contained
   here. */
/* BEGIN FILE pbuffer.h */
typedef unsigned int color_t;
typedef struct
{
  int x,y;
// ARGB
  color_t color;
} point_t;
#define D_RED(x) ((x)>>16)&0xff)
#define D_GRE(x) ((x)>>8)&0xff)
#define D_BLU(x) ((x)>>0)&0xff)
#define D_ALP(x) ((x)>>24)&0xff)
typedef struct pbuffer pbuffer_t;
pbuffer_t *pbuffer_new();
void       pbuffer_free(pbuffer_t *);
void       pbuffer_clip(pbuffer_t *B,int x, int y, int w, int h);
pbuffer_t *pbuffer_get(pbuffer_t *B, point_t **Rp, unsigned int *Rl);
void       pixel(pbuffer_t* B, int x,int y,color_t color);
void       pbuffer_unify(pbuffer_t *B);
void       pbuffer_translate(pbuffer_t *B,int dx,int dy);
/* END FILE pbuffer.h */
/* BEGIN FILE line.h */
pbuffer_t* line(pbuffer_t *B,unsigned int color,int x0, int y0, int x1, int y1);
/* END FILE line.h */
/* BEGIN FILE thick.h */
pbuffer_t* draw_varthick_line
      (pbuffer_t *B, unsigned int color,
       int x0,int y0,int x1, int y1,
       double (*left)(void *,int ,int), void *argL,
       double (*right)(void *,int ,int), void *argR);
pbuffer_t* draw_thick_line
      (pbuffer_t *B, unsigned int color,
       int x0,int y0,int x1, int y1,
       double width);
/* END FILE thick.h */
/* BEGIN FILE filledcirc.h */
pbuffer_t* draw_filled_circle
  (pbuffer_t *B, unsigned int color, int x, int y, int r) ;
/* END FILE filledcirc.h */
